# Copyright (C) 2005 EPITA Research and Development Laboratory (LRDE).
#
# This file is part of Olena.
#
# Olena is free software: you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free
# Software Foundation, version 2 of the License.
#
# Olena is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Olena.  If not, see <http://www.gnu.org/licenses/>.

require 'pathname'
# STDERR.puts "MK: #{ARGV.inspect}"
def usage
  STDERR.puts "Usage: #$0 <dest-file>"
  STDERR.puts "ac_subst_vars will be read from stdin"
  exit
end
usage if ARGV.size != 1
out_path = Pathname.new ARGV.shift
args = STDIN.read.split(/\s+/)
out_path.chmod(0644) if out_path.exist?
out_path.open('w') do |out|
  out.puts "# Generated by mk_local_config_rb_in.rb"
  out.puts "# dest-file: #{out_path}"
  out.puts "# ac_subst_vars: #{args.join(' ')}"
  out.puts "AC_CONFIG = {"
  args.each do |arg|
    out.puts "  :#{arg} => '@#{arg}@',"
  end
  out.puts "}"
end
out_path.chmod(0444)
